/* *** timux.h *** Simple Timer Multiplexor (headers).

              Copyright (C) 2001 Ral Nez de Arenas Coronado

        This program is free software; you can redistribute it and/or
         modify it under the terms of the GNU General Public License
                as published by the Free Software Foundation;
                      either version 2 of the License,
                   or (at your option) any later version.

       This program is distributed in the hope that it will be useful,
         but WITHOUT ANY WARRANTY; without even the implied warranty
           of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
            See the GNU General Public License for more details.

      You should have received a copy of the GNU General Public License
             (`GPL') along with this program; if not, write to:

                       Free Software Foundation, Inc.
                         59 Temple Place, Suite 330
                         Boston, MA 02111-1307  USA

                   Report bugs to <raul@pleyades.net>
*/
#ifndef __X_TIMUX_X__
#define __X_TIMUX_X__

#include <stdint.h>

/* NOTE: timestamps, and so resolutions, are expressed in milliseconds */

typedef struct TiMux *TiMux;
typedef uint_fast32_t tempus;
typedef uint_fast64_t jobid;
typedef void (*duty) (void *);

TiMux timux_create (void);
TiMux timux_delete (TiMux);
jobid timux_addjob (TiMux, duty, void *, tempus);
void  timux_deljob (TiMux, jobid);
#endif
