/*
    Filename: x.h
    Synopsis: X framework headers.
    
                        Copyright (C) 2000, 2001 
           Ral Nez de Arenas Coronado <raul@pleyades.net>
	        David Gmez Espinosa <david@pleyades.net>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to:

        Free Software Foundation, Inc.
        59 Temple Place, Suite 330
        Boston, MA 02111-1307 USA

*/
#ifndef __X__STUFF__H__
#define __X__STUFF__H__

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
#include <X11/cursorfont.h>
#include <X11/xpm.h>
#include <X11/keysym.h>
#include <X11/extensions/shape.h>
#include <sys/wait.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <stdlib.h>
#include "mobs.h"
#include "chain.h"
#include "cfgpool.h"


typedef void (*callback) (void *);

extern Display *display;
extern char *display_name;
extern Atom wm_delete;
extern Atom wm_protocols;
extern Atom wm_state;
extern Cursor x_root_cursor;
extern Window creditbar;
extern Window ROOT;
extern int DHEIGHT;
extern CfgPool pawmpool;

/*
    NOTE: using these macros before calling x_init() will result
in undefined behaviour. Well, not undefined, but *BAD* behaviour.
*/

/* Basic definitions */
#define ROOT (DefaultRootWindow(display))
#define SCREENI  (DefaultScreen(display))
#define SCREEN   (DefaultScreenOfDisplay(display))
#define VISUAL   (DefaultVisualOfScreen(SCREEN))
#define DEPTH    (DefaultDepth(display, SCREENI))
#define COLORMAP (DefaultColormap(display, SCREENI))
#define BLACK    (BlackPixel(display, SCREENI))
#define WHITE    (WhitePixel(display, SCREENI))
#define CURSOR   (x_root_cursor)
#define DWIDTH   ((unsigned int)DisplayWidth(display, SCREENI))
#define DHEIGHT  ((unsigned int)DisplayHeight(display, SCREENI))

#define GOT(event,who) SAY("Got "#event" on "#who)

/* Type of the event handlers */
typedef void (*Handler) (XEvent *, void *);

//typedef struct sPAbground *PAbground;

typedef struct sxImage {
    Pixmap pixmap;
    Pixmap mask;
    int w;
    int h;
} *xImage;

void x_init (void);
void x_done (void);
void x_dispatch (XEvent *);
void x_addsloot (Window, Handler, void *);
void x_delsloot (Window, Handler, void *);
XEvent *x_getevent (void);

Cursor x_build_cursor (unsigned char *, unsigned char *,
                       unsigned int, unsigned int, int, int);
xImage x_build_pixmap (char *);
void x_destroy_pixmap(xImage);
//void x_draw_background(void);
size_t x_trimtext (XFontStruct *, const char *, unsigned int);
unsigned long x_pixel (const char *);
unsigned long x_color (const char *);
#endif
